# P4z : Analyse de performances de différents tris

[Grille d'évaluation P4z](https://docs.google.com/spreadsheets/d/1VXeO91rhy04xa0p8KUhWliFl228utHaDir8MstO5Z-M/edit?usp=sharing
)

## Problème

Description du Problème.

Description de tous les paramètres exploratoires du problème

## Dispositif expérimental

### Application

[code source de l'application](src/Lib)
>Pour utiliser les tris, vous avez besoin de 2 choses:<br>
    - Le binaire `tri`<br>
    - Un document texte contenant les éléments du tableau, chaque élément est séparé du prochain par un espace et pour finit par un `.`. <br>
    Ex : `4 3 11 29 .`<br>

> Le binaire demande une option et un fichier, le fichier est du type de ceux définit plus haut, quant aux option il en existe plusieures : <br>
    - `-i` ou `--insertion` pour le tri à insertion
    - `-f` ou `--fusion` pour le tri à fusion
    - `-r` ou `--rapide` pour le tri rapide
    - `-a` ou `--all` pour tout les tris disponibles 
    - `-iv` ou `--insertion-verbose` pour le tri à insertion avec les affichages avancés
    - `-fv` ou `--fusion-verbose` pour le tri à fusion avec les affichages avancés
    - `-rv` ou `--rapide-verbose` pour le tri rapide avec les affichages avancés 
    - `-g` qui génére un nouveau tableau sur stdout avec une taille du tableau et un nombre max 


### Environnement de test

Description de la plateforme de test
```
Extrait pertinent de /proc/cpuinfo
```

### Description de la démarche systématique

Description de la démarche systématique et de l'espace d'exploration pour chaque paramètres.

```
Suite des commandes, ou script, à exécuter pour produire les données.
```

## Résultats préalables

### Temps d'exécution

<img src="src/Images/graphe_temps.png" width="500"/>

### Consommation mémoire

<img src="src/Images/graphe_memoire.png" width="500"/>

### Analyse des résultats préalables

Explications précises et succinctes des résultats préalables.

### Discussion des résultats préalables

Explications précises et succinctes des limites des résultats
préalables et ce qu'ils ne permettent pas de vérifier.

## Etude approfondie

### Hypothèse

Le tri insertion devient de plus en plus long quand la taille du tableau augmente, et donc celui-ci ne sait traiter efficacement uniquement des petits tableaux, étant donnée que tout les autres algorithmes coupent leurs tableaux en de plus petit tableaux, Notre hypothése est, que si le tri insertion est donc plus performant que les autres tris sur des petit tableaux, alors nous allons utiliser le tri insertion dans les autres tris, par exemple avec tri rapide.  

### Protocole expérimental de vérification de l'hypothèse

Pour ce faire nous allons donc voir si effectivement le tri insertion se déroule plus rapidement sur plein de petit tableaux, pour le test nous avons commencé avec des tableaux de taille 100, et au lieux de regarder le temps de chaque tri de faire le tri d'un tableau puis d'un autre, etc..., on va juste prendre le temps pour trier tout les tableaux.
En faisant certains test, nous avons aussi remarqué que le tri insertion est encore plus rapide lorsque les tableaux à traiter sont déjà presque triés.

Tout d'abord pour tester l'hypothése on fait un petit [script](src/Scripts/hypothese_perf.sh) pour tester, ce script à été réalisé avec 1000 tableaux de 100 éléments. 
```
./hypothese_perf.sh 
```
ce qui nous donne ![ceci](src/Images/Tri_insertion_plus_rapide.png)

Donc maintenant il faut faire un tri rapide qui utilise le tri insertion et l'intégrer au main.

### Résultats expérimentaux

### Analyse des résultats expérimentaux

### Discussion des résultats expérimentaux

## Conclusion et travaux futurs
